# uninstall GRASS before compiling this package!
%define shortver 83
%define _requires_exceptions devel\(.*\)
%define _provides_exceptions devel\(.*\)

Name:		grass
Version:	    8.3.2
Release:	%mkrel 2
Group:		Sciences/Geosciences
Summary:	Geographic Resources Analysis Support System
License:	    GPLv2+
URL:		    http://grass.osgeo.org/
Patch0:		grass-pkgconfig.patch
Patch2:		grass-8.2.0-mga-fixpath.patch

BuildRequires:	pkgconfig(xmu)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(gdlib) >= 2.0
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(cairo)
BuildRequires:	pkgconfig(glu)
BuildRequires:	unixODBC-devel
BuildRequires:	pkgconfig(fftw3)
BuildRequires:	tk
BuildRequires:	pkgconfig(tk)
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	gdbm-devel
BuildRequires:	readline-devel
BuildRequires:	postgresql-devel
BuildRequires:	gcc-gfortran
BuildRequires:	lib64gdal-devel
BuildRequires:	lib64appstream-devel
BuildRequires:	flex
BuildRequires:	swig
BuildRequires:	bison
BuildRequires:	pkgconfig(proj)
BuildRequires:	proj
BuildRequires:	tcl
BuildRequires:	pkgconfig(tcl)
BuildRequires:  lapack-devel
BuildRequires:  blas-devel
BuildRequires:  libgomp-devel
BuildRequires:	pkgconfig(cfitsio)
BuildRequires:	unixODBC-devel
BuildRequires:	mysql-devel
BuildRequires:	termcap-devel
BuildRequires:	pkgconfig(python3)
BuildRequires:	python3-wxpython4
BuildRequires:	lib64sqlite3-devel
BuildRequires:  python3-numpy
BuildRequires:  python3-six
BuildRequires:  python3-dateutil
BuildRequires:	imagemagick
BuildRequires:	lzma
BuildRequires:	pkgconfig(bzip2)
BuildRequires:	pkgconfig(libzstd)
BuildRequires:  pkgconfig(netcdf)
BuildRequires:  pkgconfig(OpenCL)
BuildRequires:  lib64pdal-devel

Requires:	xterm
Requires:	tk
Requires:	tcl
Requires:   python3-wxpython4
BuildRoot:      %{_tmppath}/%{name}-%{version}-build


%description
GRASS (Geographic Resources Analysis Support System) is an
open source, Free Software Geographical Information System (GIS)
with raster, topological vector, image processing, and graphics
production functionality that operates on various platforms
through a graphical user interface and shell in X-Window.

%prep


%build
pushd %_sourcedir
wget -nc https://grass.osgeo.org/%{name}%{shortver}/source/%{name}-%{version}.tar.gz
tar -xvf %{name}-%{version}.tar.gz -C %_builddir
popd

pushd %_builddir/%{name}-%{version}
%autopatch -p1
export LDFLAGS="-L/usr/lib64/libglvnd/ $LDFLAGS"
%configure2_5x \
	--prefix=%{_libdir} \
	--with-libs=%{_libdir} \
	--with-includes=%{_includedir} \
	--with-dbm-includes=%{_includedir}/gdbm/ \
	--with-postgres \
	--with-postgres-includes=%{_includedir}/ \
	--with-freetype \
	--with-freetype-includes=%{_includedir}/freetype2 \
	--with-motif \
	--with-cairo \
	--with-openmp \
	--with-lapack \
	--with-lapack-libs=%{_libdir} \
	--with-blas \
	--with-blas-libs=%{_libdir} \
	--with-opengl-libs=%{_libdir} \
	--with-motif-libs=%{_libdir} \
	--with-motif-includes=%{_includedir} \
	--with-gdal  \
	--with-geos \
	--with-mysql \
	--with-mysql-includes=%{_includedir}/mysql \
	--with-odbc \
	--enable-largefile \
	--with-curses \
	--with-wxwidgets="%{_bindir}/wx-config"\
	--with-sqlite \
	--with-cxx \
	--with-proj-share=%{_datadir}/proj \
	--with-nls \
	--with-readline \
	--with-bzlib \
	--with-zstd \
	--with-opencl \
	--with-opencl-libs=%{_libdir} \
	--with-netcdf

%make_build
popd

%install
%__mkdir -p %{buildroot}%{_bindir}
pushd %_builddir/%{name}-%{version}
%make_install \
        prefix=%{_libdir} \
        UNIX_BIN=%{_bindir} \
        GISBASE_RUNTIME=%{_libdir}/%{name}%{shortver}

# fix paths:
# Change GISBASE in startup script
for I in %{buildroot}%{_bindir}/%{name} \
	%{buildroot}%{_libdir}/%{name}%{shortver}/include/Make/Platform.make \
	%{buildroot}%{_libdir}/%{name}%{shortver}/include/Make/Grass.make \
	%{buildroot}%{_libdir}/%{name}%{shortver}/demolocation/.grassrc%{shortver} \
	%{buildroot}%{_libdir}/%{name}%{shortver}/etc/fontcap; do
	sed -i \
		-e 's|%{buildroot}%{_libdir}/%{name}-%{version}|%{_libdir}/%{name}%{shortver}|g' \
		-e 's|%{buildroot}%{_libdir}/%{name}%{shortver}|%{_libdir}/%{name}%{shortver}|g' \
		-e 's|%{buildroot}%{_bindir}|%{_bindir}|g' \
		$I
done

# fix paths in grass.pc
sed -i -e 's|%{_prefix}/%{name}-%{version}|%{_libdir}/%{name}%{shortver}|g' \
	%{name}.pc

mkdir -p %{buildroot}%{_libdir}/pkgconfig
install -p -m 644 %{name}.pc %{buildroot}%{_libdir}/pkgconfig

# Make man pages available on the system, convert to utf8 and avoid name conflict
mkdir -p %{buildroot}%{_mandir}/man1
for man in $(ls %{buildroot}%{_libdir}/%{name}%{shortver}/docs/man/man1/*.1)
do
	iconv -f iso8859-1 -t utf8 $man > %{buildroot}%{_mandir}/man1/$(basename $man)"%{name}"
done


# Make desktop, appdata and icon files available on the system
cp -pr %{buildroot}%{_libdir}/%{name}%{shortver}/share/* %{buildroot}%{_datadir}/
desktop-file-validate %{buildroot}/%{_datadir}/applications/*.desktop
appstream-util validate-relax --nonet %{buildroot}/%{_datadir}/metainfo/org.osgeo.%{name}.appdata.xml

# fix runtime GISBASE path
sed -i -e 's|@MGAGISBASE@|%{_libdir}/%{name}%{shortver}|g' \
	bin.%{_target_platform}/grass
cp bin.%{_target_platform}/grass %{buildroot}%{_bindir}/grass
chmod a+x %{buildroot}/usr/bin/grass

for i in {16,22,24,32,36,48,64,72,96,128,192}
do
  %__install -p -D dist.%{_target_platform}/gui/icons/%{name}-${i}x${i}.png %{buildroot}%{_iconsdir}/hicolor/${i}x${i}/apps/%{name}.png
done

%__mkdir -p %{buildroot}/%{_libdir}/grass%{shortver}/locks
%__chmod 1777 %{buildroot}/%{_libdir}/grass%{shortver}/locks


%__mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=Grass%{shortver}
Comment=Geographic Resources Analysis Support System
Exec=%{_bindir}/%{name}
TryExec=%{_bindir}/grass
Icon=%{name}
Terminal=true
Type=Application
Categories=X-MandrivaLinux-MoreApplications-Sciences-Geosciences;Science;Geology;
EOF

# Add custom lib path to ld.conf.so.d
%__mkdir -p %{buildroot}%_sysconfdir/ld.so.conf.d
cat > %{buildroot}%_sysconfdir/ld.so.conf.d/%{name}.conf << EOF
%{_libdir}/%{name}%{shortver}/lib
EOF

popd

%files
%doc 
%attr(0755,root,root) %{_bindir}/*
%{_sysconfdir}/ld.so.conf.d/*
%{_libdir}/%{name}%{shortver}/
%{_libdir}/pkgconfig/*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/metainfo/*
%{_mandir}/man1/*
%{_iconsdir}/*/*/*/*


%changelog
* Sun Mar 31 2024 pp - 8.3.2-2pclos2024
- rebuild against new pdal

* Thu Mar 14 2024 pp - 8.3.2-1pclos2024
- new version

* Tue Mar 05 2024 pp - 8.3.1-4pclos2024
- rebuilt against new proj, pdal

* Fri Jan 12 2024 pp - 8.3.1-3pclos2024
- rebuilt against new pdal

* Wed Dec 27 2023 pp - 8.3.1-2pclos2024
- rebuilt against new gdal

* Mon Nov 06 2023 pp - 8.3.1-1pclos2023
- new version

* Sun Jul 16 2023 tex - 8.3.0-2pclos2023
- rebuild against updates

* Tue Jul 11 2023 pp - 8.3.0-1pclos2023
- new version

* Thu May 11 2023 pp - 8.2.1-2pclos2023
- rebuilt against new gdal

* Thu Jan 26 2023 pp - 8.2.1-1pclos2023
- new version

* Tue Jan 03 2023 pp - 8.2.0-7pclos2023
- switch back to previous exceptions settings

* Thu Dec 29 2022 pp - 8.2.0-6pclos2023
- rebuild acc MGA

* Thu Dec 29 2022 tex - 8.2.0-5pclos2023
- rebuild against updates

* Fri Dec 16 2022 pp <pp> 8.2.0-4pclos2022
- rebuild against new gdal 3.6.1

* Thu Dec 08 2022 pp <pp> 8.2.0-3pclos2022
- rebuild against new gdal 3.6

* Sun Aug 07 2022 pp <pp> 8.2.0-2pclos2022
- rebuild against new python 3.10

* Sat Jul 02 2022 pp <pp> 8.2.0-1pclos2022
- new version

* Tue May 24 2022 pp <pp> 8.0.2-1pclos2022
- new version

* Sat May 14 2022 pp <pp> 8.0.1-4pclos2022
- rebuild against new gdal

* Sat Mar 19 2022 pp <pp> 8.0.1-3pclos2022
- removed nviz exception
- rebuit again

* Mon Mar 14 2022 pp <pp> 8.0.1-2pclos2022
- rebuid against new proj9

* Sat Mar 05 2022 pp <pp> 8.0.1-1pclos2022
- new version

* Wed Nov 10 2021 pp <pp> 7.8.6-2pclos2021
- rebuild against new gdal

* Wed Oct 20 2021 pp <pp> 7.8.6-1pclos2021
- new version

* Sat Jul 03 2021 pp <pp> 7.8.5-4pclos2021
- rebuild against new proj

* Mon May 10 2021 pp <pp> 7.8.5-3pclos2021
- rebuild against new gdal
- add hull patch

* Sun Mar 07 2021 pp <pp> 7.8.5-2pclos2021
- rebuild against new proj

* Fri Jan 08 2021 pp <pp> 7.8.5-1pclos2021
- update

* Wed Nov 04 2020 pp <pp> 7.8.4-2pclos2020
- rebuild against new gdal, proj

* Fri Oct 23 2020 pp <pp> 7.8.4-1pclos2020
- update

* Fri Jul 03 2020 pp <pp> 7.8.3-3pclos2020
- rebuild against new gdal

* Tue Jun 16 2020 pp <pp> 7.8.3-2pclos2020
- rebuild

* Sun Jun 14 2020 pp <pp> 7.8.3-1pclos2020
- add Require python3-wxpython4
- update
- use shortver variable

* Sat May 18 2019 pp <pp> 7.6.1-2pclos2019
- rebuild for new gdal

* Tue Apr 23 2019 tex 7.6.1-1pclos2019
- new

* Tue Mar 19 2019 pp <pp> 7.6.0-2pclos2019
- rebuild for new proj

* Sat Mar 09 2019 pp <pp> 7.6.0-1pclos2019
- update

* Mon Feb 18 2019 tex 7.4.4-1pclos2019
- new
